Index: oem-config/d-i/source/user-setup/functions.sh
===================================================================
--- oem-config.orig/d-i/source/user-setup/functions.sh	2009-10-16 11:56:08.000000000 -0400
+++ oem-config/d-i/source/user-setup/functions.sh	2009-10-16 11:57:19.000000000 -0400
@@ -70,3 +70,11 @@
 	fi
 	[ "$(printf %s "$1" | wc -c)" -lt 8 ]
 }
+
+password_is_not_ascii () {
+	if LC_ALL=C expr "$1" : '[[:graph:]]*$' >/dev/null; then
+		return 1 # Password all ascii characters
+	fi
+
+	return 0	
+}
Index: oem-config/d-i/source/user-setup/user-setup-ask
===================================================================
--- oem-config.orig/d-i/source/user-setup/user-setup-ask	2009-10-16 11:57:19.000000000 -0400
+++ oem-config/d-i/source/user-setup/user-setup-ask	2009-10-16 11:57:19.000000000 -0400
@@ -218,6 +218,17 @@
 #					STATE=6
 					STATE=3
 					continue
+				elif [ "$USER_PW" ] && password_is_not_ascii "$USER_PW"; then
+					db_set passwd/user-password ""
+					db_set passwd/user-password-again ""
+					db_fset user-setup/password-not-ascii seen false
+					db_input critical user-setup/password-not-ascii
+					db_fset passwd/user-password seen false
+					db_fset passwd/user-password-again seen false
+					db_fset passwd/username seen false
+					db_fset passwd/user-fullname seen false
+					STATE=3
+					continue
 				elif [ "$USER_PW" ] && password_is_weak "$USER_PW"; then
 					db_set user-setup/password-weak false
 					db_fset user-setup/password-weak seen false
Index: oem-config/d-i/source/user-setup/debian/po/ja.po
===================================================================
--- oem-config.orig/d-i/source/user-setup/debian/po/ja.po	2009-10-16 11:56:08.000000000 -0400
+++ oem-config/d-i/source/user-setup/debian/po/ja.po	2009-10-16 11:57:19.000000000 -0400
@@ -361,3 +361,18 @@
 #: ../user-setup-udeb.templates:23001
 msgid "Setting users and passwords..."
 msgstr "ユーザーとパスワードをセットアップ中..."
+
+#. Type: error
+#. Description
+#. :sl2:
+#: ../user-setup-udeb.templates:33001
+msgid "Password input error"
+msgstr "パスワード入力エラー"
+
+#. Type: error
+#. Description
+#. :sl2:
+#: ../user-setup-udeb.templates:33001
+msgid "Invalid character in password. Please try again."
+msgstr "パスワードに漢字/かなは使用できません。"
+
Index: oem-config/d-i/source/user-setup/debian/po/templates.pot
===================================================================
--- oem-config.orig/d-i/source/user-setup/debian/po/templates.pot	2009-10-16 11:56:10.000000000 -0400
+++ oem-config/d-i/source/user-setup/debian/po/templates.pot	2009-10-16 11:57:19.000000000 -0400
@@ -313,3 +313,18 @@
 #: ../user-setup-udeb.templates:23001
 msgid "Setting users and passwords..."
 msgstr ""
+
+#. Type: error
+#. Description
+#. :sl2:
+#: ../user-setup-udeb.templates:33001
+msgid "Password input error"
+msgstr ""
+
+#. Type: error
+#. Description
+#. :sl2:
+#: ../user-setup-udeb.templates:33001
+msgid "Invalid character in password. Please try again."
+msgstr ""
+
Index: oem-config/d-i/source/user-setup/debian/user-setup-udeb.templates
===================================================================
--- oem-config.orig/d-i/source/user-setup/debian/user-setup-udeb.templates	2009-10-16 11:57:39.000000000 -0400
+++ oem-config/d-i/source/user-setup/debian/user-setup-udeb.templates	2009-10-16 12:00:02.000000000 -0400
@@ -163,6 +163,12 @@
 # :sl2:
 _Description: Complete Check
 
+Template: user-setup/password-not-ascii
+Type: error
+# :sl2:
+_Description: Password input error
+ Invalid character in password. Please try again.
+
 Template: passwd/shadow
 Type: boolean
 Default: true
